// Sketch zum Testen und Kalibrieren des Flowmeters von SAIER

#define flowSignal 7

bool oldPot = 0;
bool newPot = 0;
int counter = 0;
long startTime;

void setup() {
  Serial.begin(115200);
  pinMode(flowSignal, INPUT);
}

void loop() {
  Serial.println("Waiting for water flow...");

  oldPot = digitalRead(flowSignal);
  newPot = digitalRead(flowSignal);
  
  do {
    oldPot = newPot;
    newPot = digitalRead(flowSignal);
    delay(1);
  }
  while(oldPot == newPot);


  Serial.println("Starting measurement");

  counter = 1; // first pulse was measured in do-while-loop above
  startTime = millis();

  while ( millis() - startTime < 10000) {
    oldPot = newPot;
    newPot = digitalRead(flowSignal);
    if ( newPot == 1 && oldPot == 0 ) {
      // Potential rised up
      counter ++;
    }
    delay(1);
  }

  Serial.println("Measurement ended.");
  Serial.println("--- Results: ---");

  Serial.println("Pulse-Counter: " + String(counter) + " in 10 seconds");
  
  float flow = (float(counter) / 10 + 4) / 10;
  Serial.println("Flow according to formular given in data sheet: " + String(flow) + " L/min");
  float flow10 = flow/6;
  Serial.println("Corresponds to: " + String(flow10) + " L / 10s (Duration of Measurement)");

  // adding some space before next measurement
  for(int i=0; i<5; i++) Serial.println();
  delay(3000);
  
}
